;====================================================================
;MAIN EXE-SPECIFIC DATA STRUCTURE, referenced via esi register
;====================================================================

macro ATEntry name {
  label name
	times 10	dd	?
}

;MAIN STRUCTURE FOR ALL GAME/PROC DATA/ADDRESSES
;(REGISTER MUST BE LOADED WITH PROPER BaseData VALUE BEFORE ACCESSING)

virtual at esi

EXEID			dd ?	;ID (not inverted in FASM)
GameSpeedVarADDR	dd ?	;address of game speed variable
GravityVarADDR		dd ?
DrawDistanceVarADDR	dd ?
GetEntryValueProc	dd ?	;gets T-Script entries (see "GetEntryValueProc.txt")

LocationADDR		dd ?	;points to pointer to a displaced pointer to Anne's position object
ActiveGunRef		dd ?	;this is the very base address of a set of
				;addresses and objects that, at some point,
				;include a member that points to the active
				;guns' object (currently held by the player)
BaseDDSurfaceADDR	dd ?	;points to an object ADDR from which
				;the base DirectX surfaces can be
				;retrieved
ActBiteMethodADDR	dd ?

WND_DDSetCoopLevelCode	dd ?
CONSOLECODE_BASE_MOV	dd ?	;this is the base code for cheat scan

TRESSTRDBG_JUMPADDR	dd ?
DATASEC_STARTADDR	dd ?	;start of ".data" section
DATASEC_ENDADDR 	dd ?	;end of same section

LOC_MAP_JUMP_ADDR	dd ?	;DWORD [this+2]+6 + this = addr for no loc cheat

EXEPROC_GETDDSURFDC	dd ?
EXEPROC_RELEASEDDSURFDC dd ?

LEVELNAME_OBJ		dd ?	;used to find SCN file name (this address + 20 bytes = saved file path/SCN level name)
CHECKLEVELNAMEADDR	dd ?	;code address to check for file name/LOADINITIALBITMAP
				;(code near after calls leading to "Finished Loading!" reference)
SAVE_GAME_CODE_ADDR	dd ?

DINOS_OBJECT		dd ?	;used for DINOS cheat (= "AI System" main object)
WOO_AMMO_BOOL_ADDR	dd ?	;used ONLY for demo EXE (same for others)
PLAYER_OBJ_INVUL_ADDR	dd ?

AT_MAIN_JUMP_ADDR	dd ?
NO_AT_FOUND_JUMPDEST	dd ?
AT_FOUND_JUMPDEST	dd ?
AT_MEM_ERROR_JUMPDEST	dd ?

VIDEO_OBJ_ALLOC_PROC	dd ?
VIDEO_PLAY_PROC 	dd ?

EXE_SIZE		dd ?
V_CODE_SIZE		dd ?
RDATA_START_ADDR	dd ?	;start of ".rdata" section

ACTGETOUTVTABLE 	dd ?
ACTSTAYNEARVTABLE	dd ?

WRITEJUMPADDR_WAKEUP	dd ?
WRITEJUMPADDR_SLEEP	dd ?

STRING_AI		dd ?
STRING_STAYNEARTARGET	dd ?
STRING_STAYAWAYTARGET	dd ?

DELETESWPCODE_ADDR	dd ?

CANIMAL_INIT_END_ADDR	dd ?

CANIMAL_VTABLE		dd ?

ATEntry AT100	;these help define the main VTables for new ActionTypes
ATEntry AT101
ATEntry AT102
ATEntry AT103
ATEntry AT104
ATEntry AT105
ATEntry AT106
ATEntry AT107
ATEntry AT108
ATEntry AT109
ATEntry AT110

end virtual
